### Virtual Method

# Ggit RemoteCallbacks credentials

#### Declaration [src]

    GgitCred*
    credentials (
      GgitRemoteCallbacks* callbacks,
      const gchar* url,
      const gchar* username_from_url,
      GgitCredtype allowed_types,
      GError** error
    )

#### Description

No description available.

#### Parameters

`url`

  Type: `const gchar*`

  The url.

  The data is owned by the caller of the method.
  The value is a NUL terminated UTF-8 string.

`username_from_url`

  Type: `const gchar*`

  The username extracted from the url.

  The argument can be `NULL`.
  The data is owned by the caller of the method.
  The value is a NUL terminated UTF-8 string.

`allowed_types`

  Type: `GgitCredtype`

  The allowed credential types.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the virtual function if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `GgitCred`

A `GgitCred` or `NULL` in case of an error.

The caller of the method takes ownership of the returned data, and is responsible for freeing it.
The return value can be `NULL`.